<script setup>
import ComponentExample from '@/components/ComponentExample.vue'
import MyInput from '@/components/MyInput.vue'
import { getApiStatus } from '@/services/api';
</script>

<template>
  <div class="about">
    <MyInput v-model="valueFromCounter" />
    <h1>This is an about page</h1>
    <p>value from counter: {{ valueFromCounter }}</p>
    <ComponentExample msg="message from about view" :initial-value="3" @update-value="updateValue" />
    <p>Computed x2: {{valueX2}}</p>

    <p v-if="isLoading"><b>Загрузка...</b></p>
    <p v-else>Статус сервера: {{ status }}</p> 
    <p v-if="error"><i>{{ error }}</i></p>
  </div>
</template>

<script>
export default {
  data() {
    return {
      valueFromCounter: null,
      isLoading: false,
      status: null,
      error: null
    }
  },
  methods: {
    updateValue(value) {
      this.valueFromCounter = value;
    },
    async loadStatus() {
      this.isLoading = true;
      try {
        const result = await getApiStatus();
        this.status = result.status;
      }
      catch (e) {
        console.error(e);
        this.error = 'Произошла проблема с загрузкой данных, попробуйте обновить страницу';
      }
      this.isLoading = false;
    }
  },
  computed: {
    valueX2() {
      return this.valueFromCounter * 2;
    }
  },
  mounted() {
    this.loadStatus();
  }
}
</script>

<style scoped>

</style>
